package org.amse.asves.skinCreator.model;

import org.amse.asves.skinCreator.exceptions.*;

import java.awt.Color;

/**
 *       java.awt
 *          
 *    
 *  RGB .
 * @author 
 */
public final class RGBColor {
	
	/**
	 *  ", , "
	 */
	private int myRed;
	private int myGreen;
	private int myBlue;
	
	/**
	 *       
	 *      
	 *         
	 *  Pledit.txt
	 * @example #AAFF00
	 * 			#1092FC
	 * @return  
	 */
	public String codeToHexadecimal() {
		String temp = "#";
		if (myRed < 16){
			temp += "0";
		}
		temp += Integer.toString(myRed,16);
		if (myGreen < 16){
			temp += "0";
		}
		temp += Integer.toString(myGreen,16);
		if (myBlue < 16){
			temp += "0";
		}
		temp += Integer.toString(myBlue,16);
		return temp;
	}
	
	/**
	 *    -  
	 *   
	 *  @return true     false  
 	 */
	public boolean encodeFromHexadecimal(String hex) throws InvalidValueException{
		int red, green, blue;
		if ((hex.length() == 7) && (hex.charAt(0) == '#')){
			try{
				red = Integer.parseInt(hex.substring(1,3),16);
				green = Integer.parseInt(hex.substring(3,5),16);
				blue = Integer.parseInt(hex.substring(5),16);
			}catch(NumberFormatException e){
				return false;
			}
			setRGBColor(red, green, blue);
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 *       
	 * @example 123, 32, 190
	 *  @return true     false  
 	 */
	public boolean encodeFromDecimal(String dec) throws InvalidValueException{
		int red = 0, green = 0, blue = 0;
		int separatorPosition = dec.indexOf(",", 0);
		int counter = 0;
				
		/**
		 *          
		 *   RGB
		 */
		if (separatorPosition == -1) return false; 
		
		try{
			red = Integer.parseInt(dec.substring(0, separatorPosition));
		}catch(NumberFormatException e){
			throw new InvalidValueException(" Error reading red mask");
		}
		
		//   
		for (counter = separatorPosition+1; 
			 (dec.charAt(counter) == ' ') || 
			 (dec.charAt(counter) == '\t');
			 	counter++);
		
		separatorPosition = dec.indexOf(",", counter);
		
		try{
			green = Integer.parseInt(dec.substring(counter, separatorPosition));
		}catch(NumberFormatException e){
			throw new InvalidValueException(" Error reading green mask");
		}
		
		separatorPosition = dec.indexOf(",", counter);
		
		//   
		for (counter = separatorPosition+1; 
		 (dec.charAt(counter) == ' ') || 
		 (dec.charAt(counter) == '\t');
		 	counter++);
		
		/**
		 *      // 
		 *        
		 *    - 
		 */
		
		int a = dec.indexOf("//", counter);
		int b = dec.indexOf(",", counter);
		
		if (a > b){
			if (b != -1)
				separatorPosition = b;
			else
				separatorPosition = a;
		}else{
			if (a != -1)
				separatorPosition = a;
			else
				separatorPosition = b;
		}
		
		try{
			if (!(separatorPosition == -1) || (separatorPosition >= dec.length())){
				blue = Integer.parseInt(dec.substring(counter, separatorPosition));
			} else {
				blue = Integer.parseInt(dec.substring(counter));
			}
		}catch(NumberFormatException e){
			throw new InvalidValueException(" Error reading blue mask");
		}
		
		setRGBColor(red, green, blue);
			
		return true;
		
	}

	/**
	 *      
	 *      
	 */
	public int getBlueMask() {
		return myBlue;
	}
	public int getGreenMask() {
		return myGreen;
	}
	public int getRedMask() {
		return myRed;
	}

	/**
	 *      
	 *        
	 */
	public void setBlueMask(int mask) throws InvalidValueException{
		setRGBColor(myRed, myGreen, mask);
	}
    
	public void setGreenMask(int mask) throws InvalidValueException{
    	setRGBColor(myRed, mask, myBlue);
	}
    
	public void setRedMask(int mask) throws InvalidValueException{
		setRGBColor(mask, myGreen, myBlue);
	}
	
	public boolean isInitialized(){
		return (myRed != -1);
	}
	/**
	 *   toString,
	 *   -    
	 */
	public String toString(){
		if (!isInitialized()){
			return "not initialized";
		} else {
			return "" + myRed + ", " + myGreen + ", " + myBlue;
		}
	}
	
	/**
	 *      
	 */
	public RGBColor (){
		myRed = 0;
		myGreen = 0;
		myBlue = 0;
	}
	
	/**
	 *         
	 *           
	 *     ,      
	 *           
	 *    ,     
	 *     ,    
	 * @param red
	 * @param green
	 * @param blue
	 */
	public void setRGBColor (int red, int green, int blue) throws InvalidValueException{
		if (! ((red >= -1) && (red < 256)) ){
			throw new InvalidValueException
					  (" Red Mask Value must stay between 0 and 255");
		}
		if (! ((green >= 0) && (green < 256)) ){
			throw new InvalidValueException
					  (" Green Mask Value must stay between 0 and 255");
		}
		if (! ((blue >= 0) && (blue < 256)) ){
			throw new InvalidValueException
					  (" Blue Mask Value must stay between 0 and 255");
		}
		myRed = red;
		myGreen = green;
		myBlue = blue;
		
	}
	/**
	 *   
	 */
	public RGBColor (int red, int green, int blue) throws InvalidValueException{
		setRGBColor(red, green, blue);
	}
	
	/**
	 *     
	 *  .    RGBColor  
	 *       -
	 * @param color
	 */
	public void convertFromColor(Color color){
		myRed = color.getRed();
		myGreen = color.getGreen();
		myBlue = color.getBlue();
	}
	
	/**
	 *     
	 * @param color
	 * @throws InvalidValueException
	 */
	public RGBColor (Color color) throws InvalidValueException{
		setRGBColor(color.getRed(), color.getGreen(), color.getBlue());
	}
	
	/**
	 * @return       awt
	 */
	public Color getColor(){
		return new Color(myRed, myGreen, myBlue);
	}
}
