package org.amse.asves.skinCreator.view;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


import java.util.HashMap;
import java.util.LinkedList;
import java.util.LinkedHashMap;

import org.amse.asves.skinCreator.model.ISkin;
import org.amse.asves.skinCreator.model.IProject;
import org.amse.asves.skinCreator.model.IWidget;
import org.amse.asves.skinCreator.model.Options;
import org.amse.asves.skinCreator.model.WidgetName;
import org.amse.asves.skinCreator.model.Rectangle;
import org.amse.asves.skinCreator.model.RGBColor;
import org.amse.asves.skinCreator.model.PleditParameterName;

/**
 *      
 * @author 
 *
 */
/*
 * TODO       
 */
public final class Viewer extends JPanel {
	
	static final long serialVersionUID = 0;
	
	private ISkin mySkin;
	private HashMap<Rectangle, WidgetName> mySkinMap = new LinkedHashMap<Rectangle, WidgetName>();
	private HashMap<Integer, WidgetName> myWidgetsToEdit = new HashMap<Integer, WidgetName>();
	private int myLastEditBar = 0;
	private int[] myAnalyzerState = new int[19];
	private HashMap<RGBColor, Rectangle> myColorPickers = new HashMap<RGBColor, Rectangle>();
	
	private HashMap<Rectangle, WidgetName> myGenTextLetters = new HashMap<Rectangle, WidgetName>();
	private HashMap<Rectangle, WidgetName> myTextLetters = new HashMap<Rectangle, WidgetName>();
	
	private int myClickCounter;
	private int myCurrentSong = -1;
	private boolean myPlaylistIsActive = true;
	// TODO private boolean myMainWindowIsActive = true;
	private boolean myEqualizerIsActive = true;
	private boolean myEqualizerShadeIsActive = true;
	private boolean myPlaylistShadeIsActive = true;
	int mySelectedSong = -1;
	private static boolean myIsChanged = false;
	
	public static void save(){
		myIsChanged = false;
	}
	
	public static boolean isChanged(){
		return myIsChanged;
	}
	/**
	 *     @param widgetName  
	 * @param x, @param y -     
	 *    
	 */
	private void setWidget(WidgetName widgetName, int x, int y){
		Rectangle rect = new Rectangle(x,y,
				mySkin.getWidget(widgetName).getWidth() + x,
				mySkin.getWidget(widgetName).getHeight() + y);
		
		mySkinMap.put(rect, widgetName);
		
		if (widgetName.isGenLetter()){
			//System.out.println(widgetName + " added to " + rect);
			myGenTextLetters.put(rect, widgetName);
		} else { 
		
		if (widgetName.isTextLetter()){
			//System.out.println(widgetName + " added to " + rect);
			myTextLetters.put(rect, widgetName);
		}}
		
	}
	/**
	 *     
	 *   
	 */
	private void composeMainWindow(){
		setWidget(WidgetName.MAIN_BG, 0, 0);
		setWidget(WidgetName.PREV, 16, 88);
		setWidget(WidgetName.PLAY, 39, 88);
		setWidget(WidgetName.PAUSE, 62, 88);
		setWidget(WidgetName.STOP, 85, 88);
		setWidget(WidgetName.NEXT, 108, 88);
		setWidget(WidgetName.EJECTBUTTON, 137, 89);
		setWidget(WidgetName.SHUFFLE_OFF, 164, 89);
		setWidget(WidgetName.REPEAT_ON, 210, 89);
		setWidget(WidgetName.EQBUTTON_ON, 219, 58);
		setWidget(WidgetName.PLBUTTON_ON, 242, 58);
		setWidget(WidgetName.BALANCE, 177, 57);
		setWidget(WidgetName.BALANCEBUTTON, 189, 58);
		setWidget(WidgetName.VOLUME, 107, 57);
		setWidget(WidgetName.VOLUMEBUTTON, 158, 58);
		setWidget(WidgetName.NUMBER_0, 48, 26);
		setWidget(WidgetName.NUMBER_0, 60, 26);
		setWidget(WidgetName.NUMBER_2, 78, 26);
		setWidget(WidgetName.NUMBER_0, 90, 26);
		setWidget(WidgetName.PLAYPAUS_PLAY, 26, 28);
		setWidget(WidgetName.PLAYPAUS_PLAY_POINTS, 24, 28);
		setWidget(WidgetName.DIGIT_2, 111, 43);
		setWidget(WidgetName.DIGIT_5, 116, 43);
		setWidget(WidgetName.DIGIT_6, 121, 43);
		setWidget(WidgetName.DIGIT_4, 156, 43);
		setWidget(WidgetName.DIGIT_4, 161, 43);
		setWidget(WidgetName.STEREO_ON, 239, 41);
		setWidget(WidgetName.MONO, 212, 41);
		setWidget(WidgetName.MAINTITLEBAR_ON, 0, 0);
		setWidget(WidgetName.TITLEBARMENUBUTTON, 6, 3);
		setWidget(WidgetName.MAIN_CLOSE, 264, 3);
		setWidget(WidgetName.MAIN_SHADE, 254, 3);
		setWidget(WidgetName.MAIN_HIDE, 244, 3);
		setWidget(WidgetName.POSBAR, 16, 72);
		setWidget(WidgetName.POSBARBUTTON, 30, 72);
		setWidget(WidgetName.MENU, 10, 22);
	}
	/**
	 *    
	 *   
	 */
	private void composeEqualizer(){
		setWidget(WidgetName.EQ_MAINBG, 0, 116);
		setWidget(WidgetName.EQ_TITLEBAR_ON, 0, 116);
		setWidget(WidgetName.EQ_ONBUTTON_OFF, 14, 134);
		setWidget(WidgetName.EQ_AUTOBUTTON_ON, 39, 134);
		setWidget(WidgetName.EQ_PRESETSBUTTON, 217, 134);
		setWidget(WidgetName.EQ_CURVEBG, 86, 133);
		setWidget(WidgetName.EQ_BAR, 78, 154);
		setWidget(WidgetName.EQ_BAR, 96, 154);
		setWidget(WidgetName.EQ_BAR, 114, 154);
		setWidget(WidgetName.EQ_BAR, 132, 154);
		setWidget(WidgetName.EQ_BAR, 150, 154);
		setWidget(WidgetName.EQ_BAR, 168, 154);
		setWidget(WidgetName.EQ_BAR, 186, 154);
		setWidget(WidgetName.EQ_BAR, 204, 154);
		setWidget(WidgetName.EQ_BAR, 222, 154);
		setWidget(WidgetName.EQ_BAR, 240, 154);
		setWidget(WidgetName.EQ_BAR, 21, 154);
		setWidget(WidgetName.EQ_BARBUTTON, 22, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 79, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 97, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 115, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 133, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 151, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 169, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 187, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 205, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 223, 179);
		setWidget(WidgetName.EQ_BARBUTTON, 241, 179);
		
		setWidget(WidgetName.EQ_CLOSEBUTTON, 264, 119);
		setWidget(WidgetName.EQ_SHADEBUTTON, 254, 119);
	}
	
	/**
	 *    
	 */
	private void composePlaylistTitleBar(){
		setWidget(WidgetName.PL_LEFT_UPPER_CORNER, 0, 232);
		
		for (int i = 1; i < 9; i++)
			setWidget(WidgetName.PL_TOP_FRAME_RESIZER, 25*i, 232);

		setWidget(WidgetName.PL_TITLEBAR, 225, 232);
		
		for (int i = 0; i < 8; i++)
			setWidget(WidgetName.PL_TOP_FRAME_RESIZER, 325 + 25*i, 232);
			
		setWidget(WidgetName.PL_RIGHT_UPPER_CORNER,525,232);
			
		setWidget(WidgetName.PL_CLOSEBUTTON, 539, 235);
			
		setWidget(WidgetName.PL_SHADEBUTTON, 529, 235);		
	}
	/**
	 *    
	 *   
	 */
	private void composePlaylist(){
		
		composePlaylistTitleBar();
		
		for (int i = 0; i < 6; i++)
			setWidget(WidgetName.PL_LEFT_FRAME_RESIZER, 0, 232 + 20 + 29*i);
		
		for (int i = 0; i < 6; i++)
			setWidget(WidgetName.PL_RIGHT_FRAME_RESIZER, 530, 232 + 20 + 29*i);
		
		setWidget(WidgetName.PL_BUTTONS_AREA,0,425);
		
		for (int i = 0; i < 8; i++)
			setWidget(WidgetName.PL_BOTTOM_FRAME_RESIZER,125 + i*25,425);
		
		setWidget(WidgetName.PL_VISUAL_BAR,325,425);
		setWidget(WidgetName.PL_PLAYCONTROLS_AREA,400,425);
		setWidget(WidgetName.PL_SCROLLBUTTON, 535, 252);
		
		
		setWidget(WidgetName.PL_ADD_URL, 14, 480);
		setWidget(WidgetName.PL_ADD_DIR, 14, 498);
		setWidget(WidgetName.PL_ADD_FILE, 14, 516);
		setWidget(WidgetName.PL_REM_MISC, 43, 480);
		setWidget(WidgetName.PL_REM_CROP, 43, 498);
		setWidget(WidgetName.PL_REM_ALL, 43, 516);
		setWidget(WidgetName.PL_REM_FILE, 43, 534);
		setWidget(WidgetName.PL_SEL_INVERSE, 72, 480);
		setWidget(WidgetName.PL_SEL_ZERO, 72, 498);
		setWidget(WidgetName.PL_SEL_ALL, 72, 516);
		setWidget(WidgetName.PL_MISC_SORT, 101, 480);
		setWidget(WidgetName.PL_MISC_INF, 101, 498);
		setWidget(WidgetName.PL_MISC_OPTIONS, 101, 516);
		//130  
		setWidget(WidgetName.PL_LIST_NEW, 506, 480);
		setWidget(WidgetName.PL_LIST_SAVE, 506, 498);
		setWidget(WidgetName.PL_LIST_LOAD, 506, 516);
		
		setWidget(WidgetName.PL_ADD_STRIPE, 12, 480);
		setWidget(WidgetName.PL_REM_STRIPE, 41, 480);
		setWidget(WidgetName.PL_SEL_STRIPE, 70, 480);
		setWidget(WidgetName.PL_MISC_STRIPE, 99, 480);
		setWidget(WidgetName.PL_LIST_STRIPE, 504, 480);

	}	
	
	/**
	 *     
	 */
	private void showProgramImages(){
		setWidget(WidgetName.ARROW, 14, 463);
		setWidget(WidgetName.ARROW, 43, 463);
		setWidget(WidgetName.ARROW, 72, 463);
		setWidget(WidgetName.ARROW, 101, 463);
		setWidget(WidgetName.ARROW, 506, 463);
		setWidget(WidgetName.AVS_VIS, 286, 20);
	}
	
	/**
	 *      
	 *   
	 */
	private void composeShadeWindows(){
		setWidget(WidgetName.PL_SHADE_LEFT,0,Options.SHADE_PREVIEW_Y);
		for (int i = 0; i < 19; i++)
			setWidget(WidgetName.PL_SHADE_RESIZER, 25*(i+1), Options.SHADE_PREVIEW_Y);
		setWidget(WidgetName.PL_SHADE_RIGHT_INACTIVE, 500, Options.SHADE_PREVIEW_Y);
		setWidget(WidgetName.PL_CLOSEBUTTON, 539, 603);
		setWidget(WidgetName.PL_SHADEBUTTON_INSHADE, 529, 603);
				
		// + 275  190   
		setWidget(WidgetName.MAINTITLEBAR_SHADE, 0 + 185, Options.SHADE_PREVIEW_Y - 100);
		setWidget(WidgetName.DIGIT_0, 134 + 185, Options.SHADE_PREVIEW_Y - 96);
		setWidget(WidgetName.DIGIT_0, 139 + 185, Options.SHADE_PREVIEW_Y - 96);
		setWidget(WidgetName.DIGIT_2, 147 + 185, Options.SHADE_PREVIEW_Y - 96);
		setWidget(WidgetName.DIGIT_0, 152 + 185, Options.SHADE_PREVIEW_Y - 96);
		setWidget(WidgetName.MAIN_CLOSE, 450, 503);
		setWidget(WidgetName.MAIN_SHADE, 440, 503);
		setWidget(WidgetName.MAIN_HIDE, 430, 503);
		setWidget(WidgetName.TITLEBARMENUBUTTON, 191, 503);
		
		
		setWidget(WidgetName.EQ_TITLEBAR_SHADE, 185, Options.SHADE_PREVIEW_Y - 50);
		setWidget(WidgetName.EQ_SHADEBUTTON, 439, 553);
		setWidget(WidgetName.EQ_CLOSEBUTTON_INSHADE, 449, 553);
		
	}
	
	/**
	 *      
	 */
	private void drawShadeTitles(Graphics graphics){
		graphics.setColor(Color.ORANGE);
		// 220   252
		graphics.drawString("PLAYLIST IN SHADE MODE",Options.PREVIEW_BAR_X + 252,
				Options.SHADE_PREVIEW_Y);
		//  145   30
		graphics.drawString("MAIN WINDOW IN SHADE MODE",Options.PREVIEW_BAR_X + 205 + 30,
				Options.SHADE_PREVIEW_Y - 100);
		// 140   35
		graphics.drawString("EQUALIZER IN SHADE MODE",Options.PREVIEW_BAR_X + 212 + 35,
				Options.SHADE_PREVIEW_Y - 50);
		
	}
	
	/**
	 *   
	 *
	 */
	private void composeAvs(){
		setWidget(WidgetName.GEN_TOPLEFT, 275, 0);
		//System.out.println("GEN");
		for (int i = 0; i < 3; i++){
			setWidget(WidgetName.GEN_TOPRESIZER, 300 + 25*i, 0);
			setWidget(WidgetName.GEN_TOPRESIZER, 450 + 25*i, 0);
		}
		
		setWidget(WidgetName.GEN_NONRESLEFT, 375, 0);
		setWidget(WidgetName.GEN_TITLE, 400, 0);
		setWidget(WidgetName.GEN_NONRESRIGHT, 425, 0);
		setWidget(WidgetName.GEN_CLOSE, 525, 0);
		
		for (int i = 0; i < 6; i++){
			setWidget(WidgetName.GEN_LEFTRESIZER, 275 , 20 + i*29);
			setWidget(WidgetName.GEN_RIGHTRESIZER, 542 , 20 + i*29);
		}
		setWidget(WidgetName.GEN_BOTTOMRESIZER, 275 + 125, 218);
		setWidget(WidgetName.GEN_LEFTBOTTOM, 275, 218);
		setWidget(WidgetName.GEN_RIGHTBOTTOM, 275 + 150, 218);
		setWidget(WidgetName.GEN_LEFTWALL, 275, 194);
		setWidget(WidgetName.GEN_RIGHTWALL, 275 + 267, 194);
		setWidget(WidgetName.GEN_CLOSEBUTTON, 275 + 264, 3);
		
		setWidget(WidgetName.GEN_TEXT_M, 275 + 116, 4);
		setWidget(WidgetName.GEN_TEXT_I, 275 + 116 + 8, 4);
		setWidget(WidgetName.GEN_TEXT_L, 275 + 116 + 12, 4);
		setWidget(WidgetName.GEN_TEXT_K, 275 + 116 + 17, 4);
		setWidget(WidgetName.GEN_TEXT_D, 275 + 116 + 24, 4);
		setWidget(WidgetName.GEN_TEXT_R, 275 + 116 + 30, 4);
		setWidget(WidgetName.GEN_TEXT_O, 275 + 116 + 37, 4);
		setWidget(WidgetName.GEN_TEXT_P, 275 + 116 + 43, 4);
	}
	
	public void load(IProject project){
		mySkin = project.getSkin();
		
		composeMainWindow();
		composeEqualizer();
		composePlaylist();
		composeShadeWindows();
		composeAvs();
		showProgramImages();
		
		for (int i = 0; i <= 23; i++){
			addColor(mySkin.getViscolorColor(i), i);
		}
		{
		int i = 26;
		for (PleditParameterName name : PleditParameterName.getAllParameterNames()){
			addColor(mySkin.getPleditColor(name), i);
			i++;
		}
		}
		myIsChanged = false;
	}
	/**
	 *       
	 *    mouseListener
	 *    
	 * @param project
	 */
	public Viewer(IProject project){
		load(project);
		
		//Equalizer
		/**
		 *      
		 */
		this.addMouseListener
		(new MouseAdapter(){
					
			public void mouseClicked(MouseEvent e) {
				Rectangle rect = getRectByClick(e.getX() - Options.PREVIEW_BAR_X, 
						e.getY() - Options.PREVIEW_BAR_Y);
				WidgetName name = mySkinMap.get(rect);
				RGBColor color = getColorPickerByClick(e.getX(), e.getY());
				WidgetName textSymbol = myTextLetters.get(rect);
				WidgetName genTextSymbol = myGenTextLetters.get(rect);
				
				int song = PreviewManager.getSongTitleByClick(e.getX(), e.getY());
				int selectedSong = PreviewManager.getSelectedSongTitleByClick(e.getX(), e.getY());
				
				if (e.getButton() == 1){
					
					if (textSymbol != null) {
						drawText();
						repaint();
					}else{
						if (genTextSymbol != null) {
							drawGenText();
							repaint();
						}else{
							if ((name != null) && (!name.isProgram())) {
								setWidgetToEdit(name);
								repaint();
							}
						}
					}
					if (song != -1) {
						myCurrentSong = song;
						repaint();
					}
					if (color != null){
						setColorToEdit(color);
						repaint();
					}
					
				} else {
						
				if (e.getButton() == 3){
					if (PreviewManager.isClickedOnPlaylistTitleBar(e.getX(), e.getY()) ||
						(PreviewManager.isClickedOnPlaylistButton (e.getX(), e.getY()))&& 
						(!myPlaylistIsActive)){
						//System.out.println(name);
						WindowActivityChanger.changePlaylistActivity(mySkinMap, myPlaylistIsActive);
						repaint();
					} else {
					
					if (PreviewManager.isClickedOnEqualizerTitleBar(e.getX(), e.getY()) ||
						(PreviewManager.isClickedOnEqualizerButton (e.getX(), e.getY()))&& 
						(!myEqualizerIsActive) || 
						(name == WidgetName.EQ_TITLEBAR_ON)){
						//System.out.println(name);
						WindowActivityChanger.changeEqualizerActivity
										(mySkinMap, myEqualizerIsActive);
						repaint();
					} else {
					
					if (PreviewManager.isClickedOnPlaylistShade(e.getX(), e.getY())){
						//System.out.println(name);
						WindowActivityChanger.changePlaylistShadeActivity
										(mySkinMap, myPlaylistShadeIsActive);
						repaint();
					} else {
				
					if (PreviewManager.isClickedOnEqualizerShade(e.getX(), e.getY()) ||
						(PreviewManager.isClickedOnEqualizerShadeButton (e.getX(), e.getY()))&& 
						(!myEqualizerShadeIsActive)){
						//System.out.println(name);
						WindowActivityChanger.changeEqualizerShadeActivity
										(mySkinMap, myEqualizerShadeIsActive);
						repaint();
					} else {
					
					if (name != null){
						WidgetName tmp = name.getNextStateOfButton();
						if (tmp != null) mySkinMap.put(rect, tmp);
							myClickCounter = (myClickCounter + 1) % 17;
						repaint();
					} else {
					if (selectedSong != -1) {
						mySelectedSong = selectedSong;
						repaint();
					}
				}
				}
				}
				}
				}
				}
				}
			
			}

			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				//System.out.println(e);
			}

			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub

			}
		});
	}
	
	private void drawText (){
		JFrame frame = new JFrame("EDIT - Text");
		LinkedList<IWidget> widgets = new LinkedList<IWidget>();
		for (WidgetName name : myTextLetters.values()){
			widgets.add(mySkin.getWidget(name));
		}
		frame.setBackground(Options.BGCOLOR);
		frame.getContentPane().add(new WidgetViewer(widgets));
		frame.setSize(100 + Options.WINDOW_FRAME_X,	50 + Options.WINDOW_FRAME_Y);
		frame.setVisible(true);
	}
	
	private void drawGenText (){
		JFrame frame = new JFrame("EDIT - Generator Text");
		LinkedList<IWidget> widgets = new LinkedList<IWidget>();
		for (WidgetName name : WidgetName.getGenText()){
			widgets.add(mySkin.getWidget(name));
		}
		for (WidgetName name : WidgetName.getGenTextActive()){
			widgets.add(mySkin.getWidget(name));
		}
		frame.setBackground(Options.BGCOLOR);
		frame.getContentPane().add(new WidgetViewer(widgets));
		frame.setSize(140*Options.GEN_TEXT_SCALE + Options.WINDOW_FRAME_X,	53*Options.GEN_TEXT_SCALE + Options.WINDOW_FRAME_Y);
		frame.setVisible(true);
	}
	
	/**
	 *   @param color,   
	 */
	private void setColorToEdit(RGBColor color){
		Color pulledColor
	      = JColorChooser.showDialog(this,
	                                 "Please choose color",
	                                 color.getColor());
		if (pulledColor != null){
			color.convertFromColor(pulledColor);
			myIsChanged = true;
		}
	}
	
	private RGBColor getColorPickerByClick(int x, int y){
		for (RGBColor i : myColorPickers.keySet()){
			if (myColorPickers.get(i).contains(x, y))
				return i;
		}
		return null;
	}
	
	/**
	 *      @param state
	 * @param x
	 * @param y      
	 */
	private void drawAnalyzerBar(Graphics graphics, int x, int y, int state){
		for (int i = 0; i < state; i++){
			if (mySkin.getViscolorColor(17-i).isInitialized()){
				graphics.setColor(mySkin.getViscolorColor(17-i).getColor());
				graphics.drawRect(x + Options.PREVIEW_BAR_X, y - i + Options.PREVIEW_BAR_Y, 2, 0);
			}
		}
		if (mySkin.getViscolorColor(23).isInitialized()){
			graphics.setColor(mySkin.getViscolorColor(23).getColor());
			graphics.drawRect(x + Options.PREVIEW_BAR_X, y - state + Options.PREVIEW_BAR_Y, 2, 0);
		}
	}
	/**
	 *        
	 * 
	 *     ( ) - 
	 *           ,
	 *      .
	 *       .
	 *  ()       
	 */
	private void drawSongTitle(Graphics graphics){
		graphics.setColor(new Color(mySkin.getWidget(WidgetName.TEXT_A).getPicture().getRGB(3,3)));
		graphics.setFont(new Font("TitleScrollerFont", 4, 9));
		graphics.drawString("1. Artist - Track Title (0:00)", 
				10 + Options.PREVIEW_BAR_X, 611 + Options.PREVIEW_BAR_Y);
	}
	
	/**
	 *        
	 */
	private void drawSongTitleBar(Graphics graphics){
		
		graphics.setColor(mySkin.getScrollBGColor().getColor());
		graphics.fillRect(111 + Options.PREVIEW_BAR_X, 24 + Options.PREVIEW_BAR_Y, 154, 12);
		
		graphics.setColor(new Color(mySkin.getWidget(WidgetName.TEXT_A).getPicture().getRGB(3,3)));
		graphics.setFont(new Font("TitleScrollerFont", 4, 10));
		graphics.drawString("1. Artist - Track Title (0:20)", 
				111 + Options.PREVIEW_BAR_X, 33 + Options.PREVIEW_BAR_Y);
	}
	
	/**
	 *    
	 * @param graphics
	 */
	private void drawAnalyzerBackGround(Graphics graphics){
		for (int i = 0; i < 76; i++){
			for (int j = 0; j < 16; j++ ){
				if ((i % 2 == 1) || (j % 2 == 1)){ 
					graphics.setColor(mySkin.getViscolorColor(0).getColor());
				} else {
					graphics.setColor(mySkin.getViscolorColor(1).getColor());
				}
				graphics.drawRect(24 + i + Options.PREVIEW_BAR_X, 
						44 + j + Options.PREVIEW_BAR_Y, 1, 1);
			}
		}
	}
	
	/**
	 *        
	 * Options.WIDGET_PREVIEW_SCALE
	 * 
	 * @param widgetName -   
	 */
	private void setWidgetToEdit(WidgetName widgetName){
		if (widgetName != null){
			myWidgetsToEdit.put(myLastEditBar, widgetName);	
			
			JFrame frame = new JFrame("EDIT - " + widgetName);
			frame.setBackground(Options.BGCOLOR);
			frame.getContentPane().add(new WidgetViewer(mySkin.getWidget(widgetName)));
			frame.setSize(mySkin.getWidget(widgetName).getWidth()*Options.WIDGET_PREVIEW_SCALE + Options.WINDOW_FRAME_X,
					mySkin.getWidget(widgetName).getHeight()*Options.WIDGET_PREVIEW_SCALE + Options.WINDOW_FRAME_Y);
			frame.setVisible(true);
		}
	}
	
	/**
	 *       .
	 *    ,    
	 *       
	 *       ,  
	 *     ,   ,
	 *     
	 * @param x, @param y -  
	 * @return -  
	 */
	private Rectangle getRectByClick(int x, int y){
		Rectangle tmp = new Rectangle (0, 0, Options.FRAME_WIDTH, Options.FRAME_HEIGHT);
		for (Rectangle rect : mySkinMap.keySet()){
			if (rect.contains(x, y)){
				if (rect.area() < tmp.area()){
					tmp = rect;
				}
			}
		}
		return tmp;
	}
	
	/**
	 *  .
	 *         
	 *     
	 *         -  
	 *  
	 * @param graphics
	 */
	private void drawSkin(Graphics graphics){
		//this.setBackground(Options.BGCOLOR);
		for (Rectangle rect : mySkinMap.keySet()){
			if (!((mySkinMap.get(getRectByClick(10,1)) == WidgetName.MAINTITLEBAR) && 
				(mySkinMap.get(rect) == WidgetName.TITLEBARMENUBUTTON || 
				mySkinMap.get(rect) == WidgetName.TITLEBARMENUBUTTON_PRESSED))){
				
			if (!((!myPlaylistIsActive) && 
				(mySkinMap.get(rect) == WidgetName.PL_CLOSEBUTTON || 
				mySkinMap.get(rect) == WidgetName.PL_CLOSEBUTTON_PRESSED || 
				mySkinMap.get(rect) == WidgetName.PL_SHADEBUTTON || 
				mySkinMap.get(rect) == WidgetName.PL_SHADEBUTTON_PRESSED))){
				
			if (!((!myEqualizerIsActive) && 
				(mySkinMap.get(rect) == WidgetName.EQ_CLOSEBUTTON || 
				mySkinMap.get(rect) == WidgetName.EQ_CLOSEBUTTON_PRESSED || 
				mySkinMap.get(rect) == WidgetName.EQ_SHADEBUTTON || 
				mySkinMap.get(rect) == WidgetName.EQ_SHADEBUTTON_PRESSED))){
					
			if (!((!myEqualizerShadeIsActive) && 
				(mySkinMap.get(rect) == WidgetName.EQ_CLOSEBUTTON_INSHADE || 
				mySkinMap.get(rect) == WidgetName.EQ_CLOSEBUTTON_INSHADE_PRESSED || 
				PreviewManager.rectIsEQShadeButtonInshade(rect)))){
					
			if (!((mySkinMap.get(getRectByClick(32,32)) != WidgetName.PLAYPAUS_PLAY) && 
				(mySkinMap.get(rect) == WidgetName.PLAYPAUS_PLAY_POINTS ))) { 
				
			if (!((mySkinMap.get(getRectByClick(250,500)) == WidgetName.MAINTITLEBAR_SHADE_INACTIVE) && 
				(mySkinMap.get(rect) == WidgetName.MAIN_CLOSE || 
				mySkinMap.get(rect) == WidgetName.MAIN_CLOSE_PRESSED || 
				mySkinMap.get(rect) == WidgetName.MAIN_HIDE || 
				mySkinMap.get(rect) == WidgetName.MAIN_HIDE_PRESSED || 
				mySkinMap.get(rect) == WidgetName.MAIN_SHADE || 
				mySkinMap.get(rect) == WidgetName.MAIN_SHADE_PRESSED ||
				mySkinMap.get(rect) == WidgetName.TITLEBARMENUBUTTON_PRESSED ||
				mySkinMap.get(rect) == WidgetName.TITLEBARMENUBUTTON) &&
				(rect.getCenterY() > 490))){
					
			if (!((mySkinMap.get(getRectByClick(10,1)) == WidgetName.MAINTITLEBAR) && 
					(mySkinMap.get(rect) == WidgetName.MAIN_CLOSE || 
					mySkinMap.get(rect) == WidgetName.MAIN_CLOSE_PRESSED || 
					mySkinMap.get(rect) == WidgetName.MAIN_HIDE || 
					mySkinMap.get(rect) == WidgetName.MAIN_HIDE_PRESSED || 
					mySkinMap.get(rect) == WidgetName.MAIN_SHADE || 
					mySkinMap.get(rect) == WidgetName.MAIN_SHADE_PRESSED))){
				
				try{
					graphics.drawImage(mySkin.getWidget(mySkinMap.get(rect)).getPicture(), 
							rect.AX() + Options.PREVIEW_BAR_X, 
							rect.AY() + Options.PREVIEW_BAR_Y, this);
					
				}catch(NullPointerException e){
					System.out.println(rect);
				}
			
			}
			}
			}
			}
			}
			}
			}
			
		}
		
		for (int i = 0; i < 19; i++){
			myAnalyzerState[i] = (myClickCounter*i*i*i) % 19;
		}
		
		drawAnalyzerBackGround(graphics);
		for (int i = 0; i < 19; i++){
			drawAnalyzerBar(graphics, 24 + (4 * i), 59, myAnalyzerState[i]);
		}	
		drawSongTitleBar(graphics);
		drawSongTitle(graphics);
		graphics.setColor(mySkin.getPleditColor(PleditParameterName.NormalBG).getColor());
		graphics.fillRect(11 + Options.PREVIEW_BAR_X, 252 + Options.PREVIEW_BAR_Y, 520, 173);
		
		graphics.setColor(mySkin.getPleditColor(PleditParameterName.Normal).getColor());
		graphics.setFont(new Font(mySkin.getFont(), 4, 10));
		for (int i = 1; i < 15; i++){
			if (i == mySelectedSong) {
				graphics.setColor(mySkin.getPleditColor(PleditParameterName.SelectedBG).getColor());
				graphics.fillRect(12 + Options.PREVIEW_BAR_X, 254 + 12*(i-1) + Options.PREVIEW_BAR_Y, 518, 12);
				graphics.setColor(mySkin.getPleditColor(PleditParameterName.Normal).getColor());
			}
			if (i != myCurrentSong){
				graphics.drawString(i + ". Artist - Track Title",12 + Options.PREVIEW_BAR_X, 264 + (i-1)*12 + Options.PREVIEW_BAR_Y);
				graphics.drawString("0:20",503 + Options.PREVIEW_BAR_X, 264 + (i-1)*12 + Options.PREVIEW_BAR_Y);
		
			} else {
				graphics.setColor(mySkin.getPleditColor(PleditParameterName.Current).getColor());
				graphics.drawString(i + ". Artist - Track Title",12 + Options.PREVIEW_BAR_X, 264 + (i-1)*12 + Options.PREVIEW_BAR_Y);
				graphics.drawString("0:20",503 + Options.PREVIEW_BAR_X, 264 + (i-1)*12 + Options.PREVIEW_BAR_Y);
				graphics.setColor(mySkin.getPleditColor(PleditParameterName.Normal).getColor());
			}
		}
		//graphics.drawImage(mySkin.getContainer(ContainerName.GEN).getPicture(),0,0,this);
		
	}
	
	/**
	 *  
	 * @param graphics
	 * @param setting -  
	 * @param n -          
	 */
	private void writeSetting(Graphics graphics, String setting, int n){
		graphics.setColor(Options.SETTINGS_TEXT_COLOR);
		graphics.setFont(new Font("Verdana", 4, Options.SETTINGS_FONT_SIZE));
		graphics.drawString(setting, Options.SETTINGS_FRAME_X + Options.SETTINGS_FRAME_THICKNESS*2, 
				(n+1)*(Options.SETTINGS_FONT_SIZE + 3) + Options.SETTINGS_FRAME_Y + Options.SETTINGS_FRAME_THICKNESS*2);
	}
	
	/**
	 *    viscolor
	 * @param graphics
	 * @param setting -  
	 * @param n -  
	 */
	private void writeViscolorSetting(Graphics graphics, String setting, int n){
		writeSetting(graphics, setting, n);
		drawColorBar(graphics, mySkin.getViscolorColor(n), n);
	}
	
	/**
	 *    pledit
	 * @param graphics
	 * @param setting -  
	 * @param n -  
	 */
	private void writePleditSetting(Graphics graphics, PleditParameterName name, int n){
		
		RGBColor color = mySkin.getPleditColor(name);
		//if (color == null) mySkin.setPleditColor(name, color);
		/*[Text]
		Normal=#669858
		Current=#88C875
		NormalBG=#000000
		SelectedBG=#213B21
		MbBG=#000000
		MbFG=#000000
		Font=MS Sans Serifcolor = mySkin.getPleditColor(name);
		*/
		switch (name){
		case Normal: {
			writeSetting(graphics, "Playlist Regular Text = " + color, n);
			drawColorBar(graphics, color, n);
			break;
		}
		case Current: {
			writeSetting(graphics, "Playlist Current Track Text = " + color, n);
			drawColorBar(graphics, color, n);
			break;
		}
		
		case NormalBG: {
			writeSetting(graphics, "Playlist Regular Text Background = " + color, n);
			drawColorBar(graphics, color, n);
			break;
		}
		
		case SelectedBG: {
			writeSetting(graphics, "Playlist Current Track Background = " + color, n);
			drawColorBar(graphics, color, n);
			break;
		}
		
		case MbBG: {
			writeSetting(graphics, "Mini Browser Status Bar Background = " + color, n);
			drawColorBar(graphics, color, n);
			break;
			
		}
		
		case MbFG: {
			writeSetting(graphics, "Mini Browser Status Bar Text = " + color, n);
			drawColorBar(graphics, color, n);
			break;
		}
		
		case Font : {
			writeSetting(graphics, "Font Face in Playlist and Mini Browser = " + mySkin.getFont(), n);
			break;
		}
		
		default : {
			break;
		}
		}
	}
	
	/**
	 *       
	 *       
	 * @param color - 
	 * @param n -  
	 */
	private void addColor(RGBColor color, int n){
		myColorPickers.put(color, PreviewManager.getColorRect(n));
	}
	
	/**
	 *     
	 *       
	 * @param color - 
	 * @param n -  
	 */
	private void drawColorBar(Graphics graphics, RGBColor color, int n){
		Rectangle rect = PreviewManager.getColorRect(n);
		if (color == null){
			color = new RGBColor();
		}
		if (!color.isInitialized())
			color = new RGBColor();
		graphics.setColor(color.getColor());
		graphics.fillRect(rect.AX(), rect.AY(),
				Options.COLOR_BAR_WIDTH, Options.COLOR_BAR_HEIGHT);
		graphics.setColor(Options.SETTINGS_TEXT_COLOR);
		graphics.drawRect(rect.AX(), rect.AY(), 
				Options.COLOR_BAR_WIDTH, Options.COLOR_BAR_HEIGHT);
	}
	
	/**
	 *    
	 * @param graphics
	 */
	private void drawSettingsFrame(Graphics graphics){
		graphics.setColor(Options.SETTINGS_FRAME_COLOR);
		graphics.fillRect(Options.SETTINGS_FRAME_X, Options.SETTINGS_FRAME_Y, 
				Options.SETTINGS_FRAME_WIDTH, Options.SETTINGS_FRAME_HEIGHT);
		graphics.setColor(Options.BGCOLOR);
		graphics.fillRect(Options.SETTINGS_FRAME_X + Options.SETTINGS_FRAME_THICKNESS,
				Options.SETTINGS_FRAME_Y + Options.SETTINGS_FRAME_THICKNESS,
				Options.SETTINGS_FRAME_WIDTH - 2*Options.SETTINGS_FRAME_THICKNESS,
				Options.SETTINGS_FRAME_HEIGHT - 2*Options.SETTINGS_FRAME_THICKNESS);
	}
	
	/**
	 *       
	 * @param graphics
	 */
	private void drawSettings(Graphics graphics){
		
		drawSettingsFrame(graphics);
		
		writeViscolorSetting(graphics, "Visual Analyzer Background Net = " + mySkin.getViscolorColor(0), 0);
		writeViscolorSetting(graphics, "Visual Analyzer Background Dots = " + mySkin.getViscolorColor(1), 1);
		writeViscolorSetting(graphics, "Visual Analyzer Bar Color #1 (Top) " + " = " + mySkin.getViscolorColor(2), 2);
		
		for (int i = 3; i <= 16; i++)
			writeViscolorSetting(graphics, "Visual Analyzer Bar Color #" + (i - 1) + " = " + mySkin.getViscolorColor(i), i);
		
		writeViscolorSetting(graphics, "Visual Analyzer Bar Color #16 (Bottom) " + " = " + mySkin.getViscolorColor(17), 17);
		
		for (int i = 18; i <= 22; i++)
			writeViscolorSetting(graphics, "Oscilator Bar Color #" + (i - 17) + " = " + mySkin.getViscolorColor(i), i);
		{
			int i = 26;
			for (PleditParameterName name : PleditParameterName.getAllParameterNames()){
				writePleditSetting(graphics, name, i);
				i++;
			}
		}	
		
		
		writeViscolorSetting(graphics, "Last Peak Of Analyzer Bar " + " = " + mySkin.getViscolorColor(23), 23);
		
		graphics.setColor(mySkin.getViscolorColor(0).getColor());
	}
	
	/**
	 *    
	 *   JPanel
	 */
	public void paint(Graphics graphics){
		graphics.setColor(Options.SETTINGS_FRAME_COLOR);
		graphics.fillRect(0,0,Options.FRAME_WIDTH-10,Options.FRAME_HEIGHT-10);
		graphics.setColor(Options.BGCOLOR);
		graphics.fillRect(5,5,Options.FRAME_WIDTH-20,Options.FRAME_HEIGHT-20);
		drawSkin(graphics);
		drawShadeTitles(graphics);
		
		drawSettings(graphics);

	}
	
}
