package org.amse.asves.skinCreator.view;

import javax.swing.JPanel;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.LinkedList;
import java.util.Collection;

import org.amse.asves.skinCreator.model.IWidget;
import org.amse.asves.skinCreator.model.Options;

/**
 *  
 * @author 
 *
 */
public final class WidgetViewer extends JPanel{
	
	LinkedList<IWidget> myWidgets = new LinkedList<IWidget>();
	
	static final long serialVersionUID = 0;
	
	/**
	 *    
	 * @param widget
	 */
	public WidgetViewer(IWidget widget){
		myWidgets.add(widget);
	}
	
	/**
	 *     
	 * @param widgets
	 */
	public WidgetViewer(Collection<IWidget> widgets){
		myWidgets.addAll(widgets);
	}
	
	/**
	 *  
	 *     ,
	 *       
	 */
	public void paint(Graphics graphics){
		if (myWidgets.size() == 1){
			BufferedImage image = myWidgets.get(0).getPicture();
			graphics.drawImage(image, 0, 0, image.getWidth()*Options.WIDGET_PREVIEW_SCALE, 
					image.getHeight()*Options.WIDGET_PREVIEW_SCALE, this);
		}else{
			BufferedImage image;
			final int maxWidth = 9*Options.GEN_TEXT_SCALE;
			graphics.setColor(Options.SETTINGS_TEXT_COLOR);
			graphics.setFont(new Font("TitleScrollerFont", 4, 20));
			graphics.drawString("INACTIVE LETTERS", 270, 30);
			graphics.drawString("ACTIVE LETTERS", 280, 45 + (21*Options.GEN_TEXT_SCALE));
			for (int i = 0; i < 26; i++){
				image = myWidgets.get(i).getPicture();
				graphics.drawImage(image, (i % 13)*(maxWidth + 10) + 10, (i / 13)*(7*Options.GEN_TEXT_SCALE + 10) + 40, 
					maxWidth, image.getHeight()*Options.GEN_TEXT_SCALE, this);
			}
			for (int i = 26; i < 52; i++){
				image = myWidgets.get(i).getPicture();
				graphics.drawImage(image, (i % 13)*(maxWidth + 10) + 10, (i / 13)*(7*Options.GEN_TEXT_SCALE + 10) + 80, 
								maxWidth, image.getHeight()*Options.GEN_TEXT_SCALE, this);
			}
		}
	}
}
