package org.amse.asves.skinCreator.reader;

import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.*;
import java.io.*;
import java.util.zip.*;
import java.util.*;

import org.amse.asves.skinCreator.model.ContainerName;
import org.amse.asves.skinCreator.exceptions.*;
import org.amse.asves.skinCreator.wsz.SkinFilesManager;

/**
 *  -
 *        
 * SkinFilesManager myExtracter
 * @author 
 *
 */
final class PictureReader {
	
	private SkinFilesManager myExtracter;
	private InputStream myMilkInput, myArrowInput;
	
	PictureReader(SkinFilesManager extracter){
		myExtracter = extracter;
	}
	
	/**
	 *       @param name
	 * @return --,  
	 *       
	 * (myExtracter.getDefaultSkin()),     
	 *  (myExtracter.getDefaultSkin())
	 * @throws ErrorReadingProject        
	 *   (        
	 *     )
	 * @throws Critical Error       
	 */
	private BufferedImage read(ContainerName name) throws ErrorReadingProject {
		ZipEntry containerEntry;

		InputStream inputStream;
		ZipFile skin;
		
		try {
			/*if ((name == ContainerName.BALANCE) || (name == ContainerName.VOLUME)){
				skin = myExtracter.getDefaultSkin();
			}else{*/
				skin = myExtracter.getValidSkinForContainerName(name);
			//}
			
			containerEntry = myExtracter.findValidEntry(skin, name);
			
			if ( containerEntry == null) 
				throw new ErrorReadingProject("    "
						+ containerEntry.getName());
			
			inputStream = skin.getInputStream(containerEntry);
			
			if (inputStream == null) 
				throw new ErrorReadingProject("     "
						+ containerEntry.getName());
			
			BufferedImage image = ImageIO.read(inputStream);
			
			if (image != null){
				return image;
			}else{
				try{
					skin = myExtracter.getDefaultSkin();
					containerEntry = myExtracter.findValidEntry(skin, name);
					inputStream = skin.getInputStream(containerEntry);
					return ImageIO.read(inputStream);
				} catch (IOException e1){
					throw new CriticalError("    " + 
							name + "  ");
				}
			}
		}catch(IOException e2){
			throw new ErrorReadingProject("   ");
		}
		 
	}
	
	/**
	 *  ,    @param tmp
	 *    @param name   @param image
	 */
	private void putContainer(Map<ContainerName, BufferedImage> tmp, 
							ContainerName name, BufferedImage image){
		tmp.put(name, image);
	}
	
	/**
	 *   -
	 * @return   .   - ,   - 
	 * @throws CriticalError    
	 * @throws ErrorReadingProject
	 */
	public Map<ContainerName, BufferedImage> readContainers() throws CriticalError, ErrorReadingProject{
		Map<ContainerName, BufferedImage> tmp = new HashMap<ContainerName, BufferedImage>();
		//tmp.put(ContainerName.AVS, read(ContainerName.AVS));
		putContainer(tmp, ContainerName.BALANCE, read(ContainerName.BALANCE));
		putContainer(tmp, ContainerName.CBUTTONS, read(ContainerName.CBUTTONS));
		putContainer(tmp, ContainerName.EQ_EX, read(ContainerName.EQ_EX));
		putContainer(tmp, ContainerName.EQMAIN, read(ContainerName.EQMAIN));
		putContainer(tmp, ContainerName.GEN, read(ContainerName.GEN));
		putContainer(tmp, ContainerName.GENEX, read(ContainerName.GENEX));
		putContainer(tmp, ContainerName.MAIN, read(ContainerName.MAIN));
		putContainer(tmp, ContainerName.MB, read(ContainerName.MB));
		putContainer(tmp, ContainerName.MONOSTER, read(ContainerName.MONOSTER));
		putContainer(tmp, ContainerName.NUMS_EX, read(ContainerName.NUMS_EX));
		putContainer(tmp, ContainerName.NUMBERS, read(ContainerName.NUMBERS));
		putContainer(tmp, ContainerName.PLAYPAUS, read(ContainerName.PLAYPAUS));
		putContainer(tmp, ContainerName.PLEDIT, read(ContainerName.PLEDIT));
		putContainer(tmp, ContainerName.POSBAR, read(ContainerName.POSBAR));
		putContainer(tmp, ContainerName.SHUFREP, read(ContainerName.SHUFREP));
		putContainer(tmp, ContainerName.TEXT, read(ContainerName.TEXT));
		putContainer(tmp, ContainerName.TITLEBAR, read(ContainerName.TITLEBAR));
		//putContainer(tmp, ContainerName.VIDEO, read(ContainerName.VIDEO));
		try{
			putContainer(tmp, ContainerName.VIS, ImageIO.read(myMilkInput));
			putContainer(tmp, ContainerName.ARROW, ImageIO.read(myArrowInput));
		}catch(IOException e){
			throw new CriticalError("   ");
		}
		putContainer(tmp, ContainerName.VOLUME, read(ContainerName.VOLUME));
		
		return Collections.unmodifiableMap(tmp);
	}
	
	public void initializeStreams(InputStream milk, InputStream arrow){
		myMilkInput = milk;
		myArrowInput = arrow;
	}
}
