package org.amse.asves.skinCreator.reader;

import java.io.*;
import java.util.zip.*;

import org.amse.asves.skinCreator.exceptions.*;
import org.amse.asves.skinCreator.model.TxtFileName;
import org.amse.asves.skinCreator.model.ISkin;
import org.amse.asves.skinCreator.wsz.SkinFilesManager;

/**
 *   
 * @author 
 *
 */
final class TxtFileReader {

	private SkinFilesManager myExtracter;
	private ISkin mySkin;
	
	/**
	 *         @param skin
	 *  -      @param extracter
	 */
	public TxtFileReader(ISkin skin, SkinFilesManager extracter){
		mySkin = skin;
		myExtracter = extracter;
	}
	
	/**
	 *        @param manager
	 * @see org.amse.asves.skinCreator.reader.TxtReaderManager
	 * @throws ErrorReadingProject
	 */
	private void readFile(TxtReaderManager manager) throws ErrorReadingProject{
		String fileName = manager.getFileName();
		
		ZipFile zip = myExtracter.getValidSkinForFileName(fileName);
		
		ZipEntry containerEntry = myExtracter.findValidEntry(zip, fileName);
			
		InputStream inputStream;
		try{
			inputStream = zip.getInputStream(containerEntry);
		}catch(IOException e){
			throw new ErrorReadingProject("      ");
		}
		
		BufferedReader reader = new BufferedReader(new InputStreamReader (inputStream));
		
		manager.getContent(mySkin, reader);
		
		try{
			reader.close();
		} catch(IOException e){
			throw new ErrorReadingProject("      " +
					"  " + manager.getFileName());
		}
	}
	
	/**
	 *        
	 *  @param filename   
	 *   
	 * @throws ErrorReadingProject    
	 */
	public void read(TxtFileName filename) throws ErrorReadingProject{
		switch (filename){
		case VISCOLOR :{
			readFile(new ViscolorReader());
			break;
		}
		case PLEDIT : {
			readFile(new PleditReader());
			break;
		}
		default : {
			break;
		}
		}
	}
}
